module Kameleoon
  module Exception
    class KameleoonError < ::StandardError
      def initialize(message = nil)
        super("Kameleoon error: " + message)
      end
    end
    class NotFound < KameleoonError
      def initialize(value = "")
        super(value.to_s + " not found.")
      end
    end
    class VariationNotFound < NotFound
      def initialize(id = "")
        super("Variation " + id.to_s)
      end
    end
    class ExperimentConfigurationNotFound	 < NotFound
      def initialize(id = "")
        super("Experiment " + id.to_s)
      end
    end
    class FeatureConfigurationNotFound < NotFound
      def initialize(id = "")
        super("Feature flag " + id.to_s)
      end
    end
    class FeatureVariableNotFound < NotFound
      def initialize(key = "")
        super("Feature variable " + key.to_s)
      end
    end
    class CredentialsNotFound < NotFound
      def initialize
        super("Credentials")
      end
    end
    class NotTargeted < KameleoonError
      def initialize(visitor_code = "")
        super("Visitor " + visitor_code + " is not targeted.")
      end
    end
    class NotActivated < KameleoonError
      def initialize(visitor_code = "")
        super("Visitor " + visitor_code + " is not activated.")
      end
    end
    class VisitorCodeNotValid < KameleoonError
      def initialize(message = "")
        super("Visitor code not valid: " + message)
      end
    end
  end
end